<?php
namespace Claromentis\Core\Event;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"] ?: array()) + array("_d91a7be21d972d4a" . "ac861a7352a2079f" => base64_decode("c2V" . "0Tm" . "FtZ" . "Q=="), "_96be32a6f44bf54e635e" . "1736acf7a96c" => base64_decode("c2Vy" . "aWFs" . "aXpl"), "_249e641075c6a29865e4c4b46d959e" . "7f" => base64_decode("dHJpZ2dlcl9kZXBy" . "ZWNhdGlvbg=="), "_f6ad69e5b7ae7662b1d0" . "fa05847ada65" => base64_decode("Y2xhcm9tZW50aXMvZnJhbWV3b" . "3Jr"), "_7cf327515b98333f2887781d" . "2582ce87" => base64_decode("TWV0aG9kIHNpZ25hdHVyZSBkZXByZWNhdGVkIGZvciB0aGUgRXZlbnREaXNwYXRjaGVyOjpkaXNwYXRjaCgpIHNpbmNlIENvcmUgMTAsIGR1ZSB0byBTeW1mb255IDUncyBjaGFuZ2VzOiBzd2FwIHR" . "oZSBmaXJzdCB0d28gYXJndW1lbnRzIHRvIHRoaXMgbWV0aG9k"), "_6edacb78bd55c5015" . "af27c8ac1fcd9af" => base64_decode("bWV0aG9kX2V4aXN0c" . "w=="), "_9a9e2d14785bdbaecfc454cb00" . "9e47a7" => base64_decode("MT" . "A="), "_c244a470df52d1d5a708" . "5138ec94e393" => base64_decode("dW5z" . "ZXJp" . "YWxp" . "emU="), "_db6f0ba0791e9a635407659a9fe0" . "4e40" => base64_decode("aXNfb2Jq" . "ZWN0"));
use Claromentis\Common\ApplicationMiscellany\Finisher;
use Claromentis\Core\Services;
use Symfony\Contracts\EventDispatcher\Event;
use Symfony\Component\EventDispatcher\EventDispatcher as BaseEventDispatcher;




class EventDispatcher extends BaseEventDispatcher implements EventDispatcherInterface
{
    
    
    
    
    
    
    protected ?Finisher $finisher;
    
    
    
    
    public function __construct(Finisher $_fea16585ee8de2b835a68ccd4bc60aef = null)
    {
        parent::__construct();
        $this->finisher = $_fea16585ee8de2b835a68ccd4bc60aef;
    }
    
    
    
    
    
    
    
    
    public static function Shared()
    {
        return Services::I()->dispatcher;
    }
    
    
    
    
    
    
    
    
    
    
    
    public function dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b = null, bool $_46d17db0bd1ac920366ce3e210c240c1 = false) : object
    {
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_db6f0ba0791e9" . "a635407659a9fe" . "04e40"]($event)) {
            return $this->bcAwareDispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b, $_46d17db0bd1ac920366ce3e210c240c1);
        }
        $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_249e6410" . "75c6a2986" . "5e4c4b46d" . "959e7f"]($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_f6ad69e5b7ae766" . "2b1d0fa05847ada6" . "5"], $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_9a9e2d14785b" . "dbaecfc454cb0" . "09e47a7"], $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_7cf327515b98333f288" . "7781d2582ce87"]);
        return $this->bcAwareDispatch($_2cf093f28f4c7e718a5e8af628894c7b, $event, $_46d17db0bd1ac920366ce3e210c240c1);
    }
    
    
    
    
    
    
    
    
    
    private function bcAwareDispatch(object $event = null, ?string $_2cf093f28f4c7e718a5e8af628894c7b, bool $_46d17db0bd1ac920366ce3e210c240c1 = false) : object
    {
        if ($event === null) {
            $event = new Event();
        }
        if ($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_6edacb78bd" . "55c5015af27" . "c8ac1fcd9af"]($event, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_d91a7be21d972d4aac86" . "1a7352a2079f"])) {
            $event->setName($_2cf093f28f4c7e718a5e8af628894c7b);
        }
        if (!$_46d17db0bd1ac920366ce3e210c240c1 || !isset($this->finisher)) {
            return parent::dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b);
        } else {
            $_a6a149597bf68ad5294d98abc0bda72b = $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_96be32a6f44bf54e635" . "e1736acf7a96c"]($event);
            $this->finisher->FinishHim(function ($request, $_fd5a3a643834299cbdadfc3540ba0bcb) use($_2cf093f28f4c7e718a5e8af628894c7b, $_a6a149597bf68ad5294d98abc0bda72b) {
                $event = $GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_c244a470df52d1d5a7085138e" . "c94e393"]($_a6a149597bf68ad5294d98abc0bda72b);
                $this->dispatch($event, $_2cf093f28f4c7e718a5e8af628894c7b, false);
            });
            return $event;
        }
    }
}